@use "sass:map";
@use "../../core/" as adm;

$name: 'adm-formfield';
$component-tokens: (
	#{$name}: (
		default: (
            // backgrounds 
            background: transparent,
            background-hover: adm.c-token($name, 'background'),
            background-focus: adm.c-token($name, 'background'),
            
            // borders
            border: 1px solid grey,
			border-hover: adm.c-token($name, 'border'),
			border-focus: adm.c-token($name, 'border'),

            // outline for focus
			outline-offset: 2px,            
            outline: 2px solid #000,
						
            // misc
            radius: 4px,
            gap: 0.5rem,
            transition: 'all 0.2s ease-in-out',

            // size
            width: 100%,
            height: auto,

            // textarea height
            textarea-height: auto,

            // icon
            icon: adm.svg-icon('<svg width="32" height="32" viewBox="0 0 32 32" xmlns="http://www.w3.org/2000/svg" fill="var(--adm-icon-color)"><path  d="M26.0605 12.5605L14.7205 23.9005C14.4385 24.1825 14.0575 24.34 13.66 24.34C13.2625 24.34 12.88 24.1825 12.5995 23.9005L7.41998 18.721C6.83348 18.1345 6.83348 17.1865 7.41998 16.6C8.00648 16.0135 8.95448 16.0135 9.54098 16.6L13.66 20.719L23.9395 10.4395C24.526 9.85301 25.474 9.85301 26.0605 10.4395C26.647 11.026 26.647 11.974 26.0605 12.5605Z"/></svg>', '#000000'),
            icon-transition: 'all 0.2s ease-in-out',
            icon-size: 100%,

            // select options
            select-icon: adm.svg-icon('<svg width="24" height="24" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg" fill="var(--adm-icon-color)"><path d="M5.25 9.67857L6.078 10.5L12 4.625L17.922 10.5L18.75 9.67857L12.414 3.39286L12 3L11.586 3.39286L5.25 9.67857Z"/><path d="M18.75 14.3214L17.922 13.5L12 19.375L6.078 13.5L5.25 14.3214L11.586 20.6071L12 21L12.414 20.6071L18.75 14.3214Z"/></svg>', '#000000'),
            select-icon-position: calc(100% - 1rem),

            // label
            label-font-family: inherit,
            label-font-size: 1rem,
            label-font-weight: 400,
            label-line-height: 1.5rem,

		),
	),
) !default;

@mixin generate-component-markup() {
    :host {
        display: block;
        width: 100%;
        box-sizing: border-box;
    }

    .#{$name} {
        
        .formfield-wrapper {
            display: block;
            position: relative;
        }

        .formfield-input,
        .formfield-select,
        .formfield-textarea {
            position: relative;
            background-color: adm.c-token($name, 'background');
            border: adm.c-token($name, 'border');
            border-radius: adm.c-token($name, 'radius');
            outline-offset: adm.c-token($name, 'outline-offset');
            padding: adm.c-token($name, 'padding-y') adm.c-token($name, 'padding-x');
            width: adm.c-token($name, 'width');
            height: adm.c-token($name, 'height');
            box-sizing: border-box;
        }

        .formfield-textarea {
            height: adm.c-token($name, 'textarea-height');
        }
        .formfield-select {
            background-image: adm.c-token($name, 'select-icon');
            background-position: adm.c-token($name, 'select-icon-position') center;
            background-repeat: no-repeat;
            appearance: none;
        }

        .formfield-label {
            display: block;
            font-family: adm.c-token($name, 'label-font-family');
            font-size: adm.c-token($name, 'label-font-size');
            font-weight: adm.c-token($name, 'label-font-weight');
            line-height: adm.c-token($name, 'label-line-height');

            &:empty {
                display: none;
            }
        }

        .formfield-icon {
            pointer-events: none;
        }

        .formfield-error {

        }

        .label {
            font-family: adm.c-token($name, 'label-font-family');
            font-size: adm.c-token($name, 'label-font-size');
            font-weight: adm.c-token($name, 'label-font-weight');
            line-height: adm.c-token($name, 'label-line-height');
        }  
    }

    :host([disabled]),
    [disabled] {
        opacity: 0.4;
        pointer-events: none;
    }

    @content;
}